package command;


import issue.Issue;
import org.eclipse.jgit.api.Git;
import org.eclipse.jgit.api.errors.GitAPIException;
import org.eclipse.jgit.internal.storage.file.FileRepository;
import org.eclipse.jgit.lib.Repository;
import org.eclipse.jgit.storage.file.FileRepositoryBuilder;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectOutputStream;

public class CommandCreate implements Command {

    private String title;
    private String description;
//    private String path = "/home/jack/Documents/testrepo/";
    private String path = "/home/jack/Documents/issue-worktree";

    public CommandCreate(String[] args) {
        this.title = args[0];
        this.description = args[1];
    }

    private void writeIssue(Issue issue) {

        FileOutputStream fileOutputStream;
        try {
            fileOutputStream = new FileOutputStream(path + issue.getOriginalHash());
            ObjectOutputStream objectOutputStream = new ObjectOutputStream(fileOutputStream);
            objectOutputStream.writeObject(issue);
            objectOutputStream.flush();
            objectOutputStream.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }


    private void commitAndPush(Issue issue) {
        try (Git git = Git.open(new File(path))) {

            if (git.getRepository().getBranch().equals("issues")) {
                writeIssue(issue);
                git.add().addFilepattern(String.valueOf(issue.hashCode())).call();
                git.commit().setMessage("issue created: " + issue.hashCode() + " - title: " + issue.getTitle()).call();
            } else {
                git.checkout().setName("issues").call();
                writeIssue(issue);
                git.add().addFilepattern(String.valueOf(issue.hashCode())).call();
                git.commit().setMessage("issue created: " + issue.hashCode() + " - title: " + issue.getTitle()).call();
            }

        } catch (GitAPIException | IOException e) {
            e.printStackTrace();
        }
    }

    public void execute() {
        Issue issue = new Issue(title, description);
        commitAndPush(issue);
    }
}
